#!/usr/local/bin/perl

print "Content-type: text/html\n\n";     # Print errors or count on the page

############################################################################
#
#   Bestdam Logger Lite   by Keith Parkansky
#     Copyright 1999,2000 All rights reserved.
#
#      Perl script - Version 2.1 - SSI required
#
#      For a detailed explanation of how to set up this script,
#      please read the README.TXT file accompanying this script
#      or go to 
#                 http://www.execpc.com/~keithp/
#
#      Here's the short explanation:
#
#      1. In this file:  verify the path to your Perl installation
#                        given in the first line of this file and
#                        modify if necessary.
#
#      2. In this file:  enter your values for the variables below.
#
#      3. Add this SSI directive tag to each Web page that you want
#         to monitor:
#
#            <!--#exec cgi="/cgi-bin/bdlogger/bdlogger.pl" -->
#
#      4. On the server, create a sub-directory under cgi-bin
#         called 'bdlogger'.
#
#      5. USING  ASCII  MODE !, ftp the all the files to this new
#         bdlogger directory.
#
#      6. CHMOD the files as follows:   bdlogger.pl   755
#                                       period.log    666
#                                       history.log   666
#                                       trigger.dat   666
#                                       pagehits.cnt  666
#                                       iptrack.num   666  (Deluxe only)
#
#      7. If you want to use IP blocking, you must create a
#         text file with the name 'ipblock' (no extension)
#         and transfer it with the other files and CHMOD it 
#         666 also. In the file, enter one IP address 
#         (or partial IP address for entire sub-net blocking) 
#         per line to be blocked from the counting and logging.
#         This feature is available in the Deluxe Edition only.
#
#
#      By using this script your are agreeing to the conditions of,
#      and to be bound by, the Software Licensing Agreement contained
#      in the README.TXT file.  This software cannot be distributed,
#      duplicated (except for local archival purposes), shared, or
#      otherwise diseminated, in whole or in part under any circumstances
#      without prior appropriate agreement with the author.
#
#
#      www.execpc.com/~keithp/                        keithp@execpc.com
#
############################################################################


  #     YOU MUST SET THE FIRST  2  VARIABLES !

  #      Examples:   $sendto = 'bozo@circus.com';
  #                  $mailprgm = '/usr/lib/sendmail';

  #  The remaining variables are for customization

#------------------------------------------------------

  # E-mail address to send reports to  -  MUST ENTER

$sendto = 'me@mydomain.com';

#------------------------------------------------------

  # Path to your host's e-mail program  -  MUST ENTER

  # If your host has sendmail but the default
  # value below doesn't work, another common path
  # is   /bin/sendmail   but be sure to keep the
  # -t switch

$mailprgm = '/usr/lib/sendmail -t';

  # NT Users
  # If you are using Blat on NT, enter BLAT
  # (in upper-case) for the   $mailprgrm   variable above
  # and verify/enter the correct path to your
  # installation of Blat in the   $blat_path   variable
  # below.  Note that the two back-slash characters are
  # required to separate directory levels.  The default
  # installation path for Blat is given as the default
  # value for this variable.

    # NT Only
  $blatpath = 'c:\\Winnt\\System32\\blat.exe';

#------------------------------------------------------
#-----  '1' is the only valid setting in the Lite Edition

  # Update & mail logs  not-at-all/daily/weekly
  #    0=Not-at-all / 1=Daily / 2=Weekly
  #   NOTE:  With this value set to '0' (not at all)
  #          Bestdam Logger will perform like your
  #          run-of-the-mill logger/counter.

$process_period = 1;

#------------------------------------------------------

  # E-mail the "period" log report & stats ?
  #    1=Yes / 0=No

$mail_report = 1;

#-----------------------------------------------------

  # Keep a cummulative "history log" ?
  #    1=Yes / 0=No
  #   This will be an accumulation of the daily or
  #   weekly "period" reports

$keep_history = 1;

#-----------------------------------------------------

  # Count page hits ?
  #    1=Yes / 0=No

$count_hits = 1;

#------------------------------------------------------

  # Display the counter on the page ?
  #    1=Yes / 0=No

$display_count = 1;

#------------------------------------------------------


# > > > > >  THE REMAINING 11 VARIABLES ARE ONLY
# > > > > >  APPLICABLE TO THE DELUXE EDITION


#------------------------------------------------------

  #  If weekly:  Enter a value between  0  and  6  only !
  #                    Sunday=0 ......... Saturday=6
  #              Report is mailed at your first hit of the
  #              day you specify (probably very early a.m.).

$day_of_week = 0;

#------------------------------------------------------

  # Double-space the log file in the e-mail report ?
  #    1=Yes / 0=No
  #   The "period" log file lines can be quite long.
  #   You may want to set this to 1 ("Yes") if your
  #      mail reader "wraps" text.  Adjusting the
  #      wrap width will affect log appearance.
  #      Log lines are formatted to appear correctly
  #      with a width of not less than 72 characters.
  #   NOTE that the log will be easier to read if
  #     you set your mail reader to not wrap text.

$double_space = 0;

#-----------------------------------------------------

  # Check IP address so multiple hits from
  # the same address aren't counted  ?
  #    1=Yes / 0=No
  # DON'T set to '1' if you are monitoring mutliple pages

$check_ip = 1;

  # The default level of "back tracking" is 5 addresses.
  # To lower this, open the 'iptrack.num' file in a
  # text editor and delete the appropriate number
  # of '0.0.0.0' IP addresses.  To increase it,
  # add the appropriate number of '0.0.0.0'
  # IP addresses with each being on their own line.

#-----------------------------------------------------

  # Reset page counts to zero when report is mailed ?
  #    1=Yes / 0=No

$reset_counts = 0;

#------------------------------------------------------

  # If 'Yes' to display:
  # Use graphics digits for counter ?
  #    1=Yes / 0=No

$graphics_count = 0;

#------------------------------------------------------

  # If 'Yes' to graphics:
  # Enter the path to the digits files RELATIVE to
  # your root URL (www.mydomain.com).
  # This value must begin and end with a '/'
  # Ex:  With the value given below, the URL to the
  # digit graphics files would be www.mydomain.com/digits/

$digits_path = '/digits/';

#------------------------------------------------------

  # If 'Yes' to graphics:
  # File extension of digit graphics.
  #   If necessary - rename digit files to 1. 2. 3. etc.
  #     Ex: 1.gif 2.gif 3.gif etc.
  #   Large selection of digits are available at
  #    www.digitmania.holowww.com

$digits_type = '.gif';

  #  Don't put the digits under the CGI-BIN folder as
  #  people may not be able access them there.
  #
  #  With the above 2 values set correctly you should be
  #  able to view the digits on your browser.  Using the
  #  above settings as an example, you should be able to
  #  see the '1' digit by going to
  #     http://www.mydomain.com/digits/1.gif

#------------------------------------------------------

  # Create the hits.htm Web page to view current
  # hit counts using a browser ?
  #    1=Yes / 0=No
  # View the page at http://www.mydomain.com/hits.htm

$make_page = 0;

#------------------------------------------------------

  # If 'Yes' to create a hits.htm page,
  # you MUST enter the SYSTEM path to your Web root
  # for the hits.htm file (typically where your home 
  # page is located).

  # The value here is just an example of what's needed.
  # Be sure to leave the   '/   at the beginning and
  # the   /hits.htm';   on the end.
  # If you wish, you can use a name other than 'hits'
  # for the page.

$page_path = '/usr/local/etc/httpd/usersites/mysite/hits.htm';

#------------------------------------------------------

  # Create a Web-page version of the period report
  # (which also contains the hit count data) to
  # view using a browser ?    (preport.htm)
  #    1=Yes / 0=No
  # View the page at http://www.mydomain.com/preport.htm

$web_report = 0;

#------------------------------------------------------

  # If 'Yes' to create a preport.htm page,
  # you MUST enter the SYSTEM path to your Web root
  # for the preport.htm file (typically where your 
  # home page is located).

  # The value here is just an example of what's needed.
  # Be sure to leave the   '/   at the beginning and
  # the   /preport.htm';   on the end.
  # If you wish, you can use a name other than 'preport'
  # for the page.

$report_path = '/usr/local/etc/httpd/usersites/mysite/preport.htm';



#==========  STOP HERE !  -  Save your changes and exit
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!#

use Socket;
($sec,$min,$hour,$today,$month,$year,$weekday,$dayofyear,$isDST) = localtime(time);
$sitename = $ENV{'SERVER_NAME'};
$page = $ENV{'DOCUMENT_NAME'};
$client = $ENV{'HTTP_USER_AGENT'};
$camefrom = $ENV{'HTTP_REFERER'};
$addrin = $ENV{'REMOTE_ADDR'};
@ip = split (/\./, $addrin);
$binip = pack ("C4", @ip);
$isp = gethostbyaddr ($binip, 2);
$pagehits = 'pagehits.cnt';
$lasthit = 'trigger.dat';
$periodlog = 'period.log';
$historylog = 'history.log';


&format_fields;

open (LAST_HIT,"<$lasthit") || die 'Could not OPEN trigger file at 1';
$WkDayOfLastHit = <LAST_HIT>;
close LAST_HIT;

  if ($WkDayOfLastHit ne $weekday) {
    open (LAST_HIT,">$lasthit") || die 'Could not OPEN trigger file at 2';
    flock (LAST_HIT, 2) || die 'Could not LOCK trigger file at 2';
    print LAST_HIT $weekday;
    close LAST_HIT;
    &update_logs;
    if ($mail_report == 1) {
       if ($mailprgm eq 'BLAT') {
         &NT_mail_log;
       } 
       else {
         &mail_log;
       }
    }
  }

if ($count_hits == 1) {
  &count_up;
}

open (PERIOD_LOG,">>$periodlog") || die 'Could not OPEN period log file at 1';
flock (PERIOD_LOG, 2) || die 'Could not LOCK period log file at 1';
print PERIOD_LOG "$hitdate $hittime  $pageft   $isp  $addr  $client   $camefrom\n";
close PERIOD_LOG; 
exit;

#=======================================================================

sub count_up {
  open(PAGE_HITS, "<$pagehits") || die 'Could not OPEN count file at 1';
  while (<PAGE_HITS>) {
    chop;
    ($PageURL, $PageCount) = split(/ = /, $_);
    $Allcounts{$PageURL} = $PageCount;
    }
  close(PAGE_HITS);
  $Allcounts{$page}++;
  open(PAGE_HITS, ">$pagehits") || die 'Could not OPEN count file at 2';
  flock(PAGE_HITS, 2) || die 'Could not LOCK count file at 2';
  foreach $PageURL (sort keys(%Allcounts)) {
    print PAGE_HITS "$PageURL = $Allcounts{$PageURL}\n";
    }
  close PAGE_HITS;
  if ($display_count == 1) {
      print $Allcounts{$page};
  }
}

#----------------------------------------------------------------------

sub format_fields {
  if ((length($hour))==1) {
     $hour = "0".$hour;
  }
  if ((length($min))==1) {
     $min = "0".$min;
  }
  @months = ('01','02','03','04','05','06','07','08','09','10','11','12');
  $monthft = $months[$month];
  $dayft = $today;
  if (length($dayft)==1) {
     $dayft = '0'.$dayft;
  }
  if ($year > 99) {
     $year = $year - 100;
  }
  if ((length($year))==1) {
     $year = "0".$year;
  }
  $hitdate = "$monthft-$dayft-$year";
  $hittime = "$hour:$min";
  $pageft = sprintf("%-16s",$page);
  if (length($pageft)>16) {
     $pageft=substr($pageft,0,16);
  }
  $addr = sprintf("%-15s",$addrin);
  $isp = sprintf("%24s",$isp);
  if (length($isp)>24) {
     $isp = reverse ($isp);
     $isp = substr($isp,0,24);
     $isp = reverse ($isp);
  }
  $client = sprintf("%-65s",$client);
  if (length($client)>65) {
     $client = substr($client,0,65);
  }
  if (substr($camefrom,0,4) eq 'http') {
    $camefrom = substr($camefrom,7);
  }
}

#----------------------------------------------------------------------

sub update_logs {
  open (PERIOD_LOG,"<$periodlog") || die 'Could not OPEN period log file at 2';
  @periodloglines=<PERIOD_LOG>;
  close (PERIOD_LOG);
  open (PERIOD_LOG,">$periodlog") || die 'Could not OPEN period log file at ';
  flock (PERIOD_LOG, 2) || die 'Could not LOCK period log file at 3';
  print PERIOD_LOG "\n";
  close (PERIOD_LOG);
  if ($keep_history == 1) {
    open (HIST_LOG,">>$historylog") || die 'Could not OPEN history file';
    flock (HIST_LOG, 2) || die 'Could not LOCK history file';
    foreach $newhistoryline (@periodloglines) {
        print HIST_LOG $newhistoryline;
    }
    close(HIST_LOG);
  }
}

#----------------------------------------------------------------------

sub mail_log {
$dashes = '-' x 130;
$yesterday = $today - 1;
if ($yesterday == 0) {
  if ($monthft == 3) {
    $yesterday == 28;
  }
  else {
    if (($monthft==5) or ($monthft==7) or ($monthft==10) or ($monthft==12)) {
      $yesterday = 30;
    }
    else {
      $yesterday = 31;
    }
  }
  if ($monthft == 1){
    $monthft = 12;
  }
  else {
    $monthft = $monthft - 1;
  }
}
open (MAIL, "|$mailprgm $sendto") || die 'Could not open mail program';
print MAIL "From: Bestdam-Logger Lite\n";
print MAIL "Subject: $monthft/$yesterday Report for $sitename\n\n";
if ($count_hits == 1) {
  open(PAGE_HITS, "<$pagehits") || die 'Could not OPEN count file at 3';
  @hitfilelines=<PAGE_HITS>;
  close(PAGE_HITS);
  foreach  $hitline (@hitfilelines) {
    print MAIL $hitline;
  }
}
else {
  print MAIL "Hit counting is disabled in user settings.\n";
}
if ($keep_history == 1) {
  $history_size = (-s 'history.log');
  print MAIL "\nHistory Log file is now $history_size bytes.\n\n";
}
print MAIL "$dashes\n\n";
print MAIL "Period Log data is printed here\n";
print MAIL "with the Deluxe Edition of Bestdam Logger\n";
print MAIL 'available at http://www.execpc.com/~keithp/';
print MAIL "\n\n$dashes\n";
print MAIL "  Report compiled and sent by Bestdam Logger Lite v2.1 - http://www.execpc.com/~keithp/\n";
close (MAIL);
}

#----------------------------------------------------------------------

sub NT_mail_log {
$dashes = '-' x 130;
$yesterday = $today - 1;
if ($yesterday == 0) {
  if ($monthft == 3) {
    $yesterday == 28;
  }
  else {
    if (($monthft==5) or ($monthft==7) or ($monthft==10) or ($monthft==12)) {
      $yesterday = 30;
    }
    else {
      $yesterday = 31;
    }
  }
  if ($monthft == 1){
    $monthft = 12;
  }
  else {
    $monthft = $monthft - 1;
  }
}

$from = 'Bestdam-Logger Lite';
$subject = "$monthft/$yesterday Report for $sitename";
$blatprgm = "$blat_path - -t $sendto -s \"$subject\" -q";

open (MAIL, "|$blatprgm -f \"$from\" ") || die 'Could not open mail program';


if ($count_hits == 1) {
  open(PAGE_HITS, "<$pagehits") || die 'Could not OPEN count file at 3';
  @hitfilelines=<PAGE_HITS>;
  close(PAGE_HITS);
  foreach  $hitline (@hitfilelines) {
    print MAIL $hitline;
  }
}
else {
  print MAIL "Hit counting is disabled in user settings.\n";
}
if ($keep_history == 1) {
  $history_size = (-s 'history.log');
  print MAIL "\nHistory Log file is now $history_size bytes.\n\n";
}
print MAIL "$dashes\n\n";
print MAIL "Period Log data is printed here\n";
print MAIL "with the Deluxe Edition of Bestdam Logger\n";
print MAIL 'available at http://www.execpc.com/~keithp/';
print MAIL "\n\n$dashes\n";
print MAIL "  Report compiled and sent by Bestdam Logger Lite v2.1 - http://www.execpc.com/~keithp/\n";
close (MAIL);
}

####################################################################
