package Headlines;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

#require Exporter;
#require AutoLoader;
require LWP::UserAgent;
require  HTTP::Request;
#@ISA = qw(Exporter AutoLoader);
@ISA = qw(LWP::UserAgent HTTP::Request);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	
);
$VERSION = '0.5';


# Preloaded methods go here.



sub new {
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $title = shift;
  my $url = shift;
  my $self  = {};
  $self->{url} = $url;
  $self->{title} =  $title;
  bless ($self, $class);
  return $self;
}
sub caption {
  my $self =shift;
  return $self->{title};
}
sub  retrieve {
  my $self = shift;
  my $ua = new LWP::UserAgent;
  $ua->agent("AgentName/0.1 " . $ua->agent);
  my $req = new HTTP::Request GET => $self->{url};
  # Pass request to the user agent and get a response back
  my $res = $ua->request($req);
  # Check the outcome of the response
  if ($res->is_success) {
    return $res->content;
  } else {
    print STDERR "Bad luck this time, retrieving $self->{url}\n";
    return 0;
  }
}
sub parse {
  my $self=shift;
  my $rs = shift;
  my $fs =shift;
  my $beg = shift;
  my $headline_no = shift;
  my $link_no = shift;
  my $s = $self->retrieve;
  my @recs = split($rs,$s);
  my $result = [];
  my $i ="";
  my $j=0;
  foreach ($j=$beg;$j < $#recs;$j++) {
    $i = $recs[$j];
    my @fields = split($fs,$i);
    push @$result, [ $fields[$headline_no],$fields[$link_no]];
  }
  return $result;
}
1;

# Autoload methods go after =cut, and are processed by the autosplit program.

__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

Headlines - Perl extension for blah blah blah

=head1 SYNOPSIS

  use Headlines;
   my $h = Headlines::Ultra->new('slashdot','http://slashdot.org/ultramode.txt');
   print "<h1>" , $h->caption, "</h1>";
  my $result= $headline->parse;
  foreach $j (@$result ) {
    my ($headline,$url) = @$j;
    print $handle "<a href='$url'>$headline</a><br><br>";
  }


=head1 DESCRIPTION

This module is retrieving headlines of various news sources.


=head1 AUTHOR

Fred Fahnert, headlines.module@netfinances.com

=head1 SEE ALSO

perl(1).

=cut

