 
package Headlines::Generic;
use Headlines;
@ISA=("Headlines");
use HTML::Parser;
use HTML::TreeBuilder;


           sub new {
               my $proto = shift;
               my $class = ref($proto) || $proto;
	       my $title = shift;
	       my $url = shift;
	       my $regexp = shift;
               my $self  = $class->SUPER::new($title,$url);
               $self->{regexp}        = $regexp;
               bless ($self, $class);          # reconsecrate
               return $self;
           }
sub parse {
  my $self=shift;
  my $linkno=0;
  my %res = ();
  my %used= ();
#  print STDERR "Retrieving Document\n";
  my $doc = $self->retrieve;
#  print STDERR "Document Retrieved\n";
  my $result = [];
  my $h = new HTML::TreeBuilder;
  $h->parse($doc);
  for $i (@{ $h->extract_links(qw(a))}) {
    my ($link, $linkelem)= @$i;
#    print $link, "\n";
    my $k;
    my $content="";
    my $regexp = $self->{regexp};
    if ($link =~ m,$regexp,) {
      foreach $k (@{$linkelem->content}){
#	print "Found Content\n";
#	print $k unless (ref($k));
	$content .=  $k unless (ref($k));
	if (ref($k)){
	  if ($k->tag =~ /IMG/i) {
	    $content .= $k->attr('alt');
	  } else {
	    $content .= $k->as_HTML;
	  }
	}
      }
      if ( $link =~ m~javascript:(openWindowDtn|openwin).\s*.([^\'\"]+).\s*,~i){
	$link = $3;
      }
      if ($link =~ m,^/,) {
	my $base = $self->{url};
	$base =~ s,^(http://[^\/]+/).*$,$1,ig;
      }
      unless ($link =~ m,http://,) {
	my $base = $self->{url};
	$base =~ s,^(http://[^\/]+/).*$,$1,ig;
	$link = $base . $link;
      }
      unless (($link =~ /^mailto:/) || (length($link) < 5) || (length($content) < 2)){
	unless ( $self->{url} =~ /register.co.uk/) {
	  $res{$linkno++} = [$content, $link];
	} else {
	  $linkno = $link;
	  $linkno =~ s/\D+//ig;
	  $res{ - $linkno} = [$content, $link];
	}	  
#	push @$result, [ $content,$link] ;
      }
    }
  }
  my $l;
  foreach $l (sort {$a <=> $b} keys %res) {
    if (!exists($used{$res{$l}->[0]})) {
#      print "Found the following link:", $res{$l}->[0], "\t",$res{$l}->[1],"\n";
      push @$result, [$res{$l}->[0], $res{$l}->[1]];
      $used{$res{$l}->[0]} = $res{$l}->[1];
    } 
  }
	
  return $result;
}
 
1;
