#!/usr/bin/perl
#
#               -------------
#				   Links
#               -------------
#               Links Manager
#
#         File: admin.cgi
#  Description: This is the administrative interface for the links program.
#       Author: Alex Krohn
#        Email: alex@gossamer-threads.com
#          Web: http://www.gossamer-threads.com/
#      Version: 1.11
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Please check the README file for full details on registration.
# =====================================================================
#
# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \
	
	require 5.001;							# Make sure we have at least perl 5.001.
    require "links.cfg";					# Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db.pl";           # Database Routines.
    require "$db_lib_path/admin_html.pl";   # Get Admin HTML routines.
};

if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
	exit;
}

$db_script_url = "$db_script_url$ENV{'PATH_INFO'}";

# ========================================================

eval { &main; };					        # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 

# ========================================================

sub main {
# --------------------------------------------------------
    $| = 1;									 # Flush Output Right Away

    local(%in)   = &parse_form;					 # Get Form Results

    # Main Menu. Check to see what the user requested, then if he has permission for that
    # request, do it. Otherwise send the user off to an unauthorized request page.

	# The functions beginning with &html_ can be found in admin_html.pl, while the other
	# functions can be found in db.pl
	
    if    ($in{'add_form'})             { &html_add_form; } 			# Display the Add Record Form.
    elsif ($in{'add_record'})           { &add_record; }				# Add the Actual Record.
	elsif ($in{'add_record_mult'})      { &add_record_mult; }			# Add Multiple Records at once (beta).
    elsif ($in{'view_search'})          { &html_view_search; }			# Display form to search database.
    elsif ($in{'view_records'})         { &view_records; }				# Search database and print results.
    elsif ($in{'delete_search'})        { &html_delete_search; }		# Display the form to search for records to delete.
    elsif ($in{'delete_form'})          { &html_delete_form; }			# Display the form to pick records to delete.
    elsif ($in{'delete_records'})       { &delete_records; }			# Delete records.
    elsif ($in{'modify_search'})        { &html_modify_search; }		# Display the form to search for records to modify.
    elsif ($in{'modify_form'})          { &html_modify_form; }			# Display the form to pick record to modify.
    elsif ($in{'modify_form_record'})   { &html_modify_form_record; }	# Display the form to modify a record.
    elsif ($in{'modify_record'})        { &modify_record;  }			# Modify the record.
	elsif ($in{'modify_form_mult'})		{ &html_modify_form_mult; }		# Display multiple records to modify at one time.
	elsif ($in{'modify_record_mult'})	{ &modify_record_mult; }		# Modify multiple records at once.
    elsif ($in{'validate_form'})        { &html_validate_form; }		# Display the Validation Form.
    elsif ($in{'validate_records'})     { &validate_records; }			# Validate records.
	elsif ($in{'check_links'})     		{ &check_links; }				# Display/Check to make sure links have matching catgories.
	elsif ($in{'check_duplicates'})		{ &check_duplicates; }			# Display/Check for duplicate links.
    
    else					            { &html_unkown_action; }        # Uh Oh. Passed in something unkown.

#   &cgierr("Done");        # Uncomment this line for Debugging...  Will tack on form variables and environment variables
							# to the end of every page. Quite Useful.
}
