<?php

require_once("lib.settings.php");
require_once("lib.utils.php");

$badURL = FALSE;

if($rawURL)
{
    $testURL = util_validURL($rawURL);

    if($testURL)
    {
        $URL = util_encodeURL($rawURL);
        header("Location: ".ARBITROWEB_URL_MAIN."/$URL/");
        exit();
    } else
    {
        $badURL = $rawURL;
    }
}

if(!$badURL && $failedURL)
{
	$failedURL = util_decodeURL($failedURL);
}

$isCGI = FALSE;
if (php_sapi_name() == "cgi")
{
    $isCGI = TRUE;
}


?>
<html>
<head>
	<title>ArbitroWeb v<?php echo ARBITROWEB_VERSION; ?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<meta name="description" content="ArbitroWeb anonymous web surfing script v<?php echo ARBITROWEB_VERSION; ?>">
	<meta name="keywords" content="ArbitroWeb, arbitroweb v<?php echo ARBITROWEB_VERSION; ?>, anonymous surfing, privacy, security, anonymity, sventech.com">
	<link rel="stylesheet" href="style.css">
</head>
<body bgcolor="#000000">
	<h3><a href="http://sourceforge.net/projects/arbitroweb/">ArbitroWeb</a> v<?php echo ARBITROWEB_VERSION; ?></H3>
	<p>
	<?
	if(!$badURL && $failedURL)
	{
		echo "Failed to open URL : <b>".$failedURL."</b>";
	} elseif( $badURL )
    {
        echo "BAD URL : <b>".$badURL."</b>";
    }

    if($isCGI)
    {
?>
    <p class="fatalerror"><b>FATAL ERROR.</b><br>
    Your <a href="http://php.net/manual/en/function.php-sapi-name.php" class="fatalerror">SAPI</a> for
    <a href="http://www.php.net" class="fatalerror">PHP</a> is configured as CGI.<br>
    ArbitroWeb is unable to work in this environment.<br>
    Please switch to a <a href="http://www.php.net/manual/en/installation.php" class="fatalerror">non-CGI approach</a>.<br>
    If you are using <a href="http://httpd.apache.org/" class="fatalerror">Apache</a> as your web server,
    consider modifying your <a href="http://httpd.apache.org/docs/configuring.html" class="fatalerror">httpd.conf</a> to switch from using
    <a href="http://httpd.apache.org/docs/mod/mod_alias.html#scriptalias" class="fatalerror"><code>ScriptAlias</code></a> and
    <a href="http://httpd.apache.org/docs/mod/mod_actions.html#action" class="fatalerror"><code>Action</code></a> to using
    <a href="http://httpd.apache.org/docs/mod/mod_so.html#loadmodule" class="fatalerror"><code>LoadModule</code></a>.</p>
<?php
    }
	?>
	<form name="arbitroweb" method="GET" action="">
	<input type="text" name="rawURL" size=45 maxlength=500 value="<?php
	if(isset($rawURL))
    {
        echo $rawURL;
    } elseif($failedURL)
	{
		echo $failedURL;
	} else
	{
		echo "http://";
	}
	?>" <?php if($isCGI) { echo "DISABLED"; } ?>>
	<input type="submit" value="Open" <?php if($isCGI) { echo "DISABLED"; } ?>>
	</form>
	</p>
	<hr>
	<h3>Popular Places</h3>
<?php
function linkto($url, $desc)
{
	printf("<a href=\"%s/%s\">%s</a><br>",
		ARBITROWEB_URL_MAIN, util_encodeURL($url), $desc);
}

	linkto("http://www.google.com/", "Google.");
	linkto("http://groups.google.com/", "Google Groups.");
	linkto("http://images.google.com/", "Google Images.");
?>

	<p>
<?php
	$archives = array();
	$d = dir(".");
	while($entry=$d->read()) {
		if(is_file($entry))
		{
			if(eregi("^arbitroweb_[0-9.]*.tar.gz$", $entry))
			{
				$archives[] = $entry;
			}
		}
	}
	$d->close();

	if(count($archives))
	{
		printf("<hr>");
		printf("<h3>Download(s)</h3>");
		while(list($key, $tgz) = each($archives))
		{
			printf("<a href=\"%s\"><code>%s</code></a> - %dk<br>",
				$tgz, $tgz, (filesize($tgz)/1024));
		}
	}
?>
	</p>
</body>
</html>
