<?php

function util_rot13($s)
{
	return ! $s ? "" :
	strtr($s,"NnOoPpQqRrSsTtUuVvWwXxYyZzAaBbCcDdEeFfGgHhIiJjKkLlMm",
	         "AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz");
}

function util_alnum_encode($str)
{
	$ret = "";
	$slen = strlen($str);

	for($i=0; $i<$slen; $i++)
	{
		if(strstr("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ", $str[$i]))
		{
			$ret .= $str[$i];
		} else
		{
			$ret .= sprintf("%03d", ord($str[$i]));
		}
	}
	return $ret;
}

function util_alnum_decode($str)
{
	$ret = "";
	$slen = strlen($str);

	for($i=0; $i<$slen; $i++)
	{
		if(strstr("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ", $str[$i]))
		{
			$ret .= $str[$i];
		} else
		{
			$ret .= chr(substr($str, $i, 3));
			$i += 2;
		}
	}

	return $ret;
}

function util_encodeURL($str)
{
	return util_alnum_encode(util_rot13(strrev($str)));
}

function util_decodeURL($str)
{
	return strrev(util_rot13(util_alnum_decode($str)));
}

function util_glueURL($url_array)
{
    $url = "";
    extract($url_array); //extract variables

    if (isset($scheme))
    {
        $url = "$scheme:";
    }

    if (isset($host))
    {
        $url .= "//$host";
        if (isset($port))
        {
            $url .= ":$port";
        }
    }

    if (isset($path))
    {
        $url .= $path;
    }

    if (isset($query))
    {
        if (!isset($path))
        {
            $url .= "/";
        }
        $url .= "?$query";
    }

    if (isset($fragment))
    {
        $url .= "#$fragment";
    }

    return $url;
}


function util_validURL($testURL)
{
    $url_array = parse_url($testURL);
    extract($url_array);

    if(isset($scheme) && isset($host))
    {
        if(strlen(trim($path)) <= 0)
        {
            $path = "/";
        }

        $url_array = compact('scheme','host','port','path','query','fragment');
        return util_glueURL($url_array);
    } else
    {
        return FALSE;
    }
}

function getRootSelfURL()
{
	global $PHP_SELF;

	$ppos = strrpos($PHP_SELF, "/");

	if($ppos === FALSE)
	{
		return $PHP_SELF;
	}
	else
	{
		return substr($PHP_SELF, 0, $ppos);
	}
}

/*
 * The Log File Format is in the structure below
 * hostip - module [time] "request" status -
 * [time] is defined as [23/Aug/2001:21:45:59 -0400]
 */
function util_writelog($module, $request, $status)
{
	global $REMOTE_ADDR;
	if(ARBITROWEB_FLAG_LOGGING)
	{
		$logline = $REMOTE_ADDR." v".ARBITROWEB_VERSION." ".$module;
		$logline .= " [".date("d/M/Y:H:i:s Z")."] ";
		$logline .= "\"".$request."\" ".$status." -\n";
		error_log($logline, 3, ARBITROWEB_FILENAME_LOG);
	}
}

?>