#########################################################
#														#
# 			 N O  F R E E  S U P P O R T  !!			#
#														#
#########################################################

#########################################################
#		F R E E  S O F T W A R E  L I C E N S E   		#
#########################################################
#														#
# This PayPal Tools & Interfaces Software 				#
# is Copyright(C) of David W. Van Abel, 2003.			#
#														#
# This program is free software; you can redistribute 	#
# it and/or modify it under the terms of the GNU 		#
# General Public License as published by the Free 		#
# Software Foundation; either version 2 of the License, #
# or (at your option) any later version.				#
#														#
# This program is distributed in the hope that it will 	#
# be useful, but WITHOUT ANY WARRANTY; without even the #
# implied warranty of 									#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  #
# See the GNU General Public License for more details.	#
#														#
# You should have received a copy of the GNU General 	#
# Public License along with this program; if not, write #
# to the Free Software Foundation, Inc., 59 Temple 		#
# Place, Suite 330, Boston, MA  02111-1307  USA			#
# FULL LICENSE IS FOUND AT 								#
# http://opensource.org/licenses/index.html				#
#														#
# David W. Van Abel	- Author							#
# 2131 S. Allison Court									#
# Lakewood, CO USA 80227								#
# 303-249-3855 (V)										#
# dave@vanabel.com										#
# http://vanabel.com									#
# http://perlsources.com								#
# http://ipnhosting.com									#													#
#														#
#########################################################
# 				E N D  O F  L I C E N S E				#
#########################################################

#################
# Version Notes #
#################

package MODULES::Ipnx;
use strict;
use vars qw($VERSION);
$VERSION = '1.00';
use vars qw($scriptname $version $ver_date);

sub Generic_Date_Stamp {
	use vars qw($year $month $day  $hour $min $sec $len $stamp $a);
	($a) = @_;
	($sec, $min, $hour, $day, $month, $year) = localtime();
	$year = 2000 + $year - 100;
	$month = $month +1;
	$len = length($year);
	if ($len < 2) {$year = "0$year"}
	$len = length($month);
	if ($len < 2) {$month = "0$month"}
	$len = length($day);
	if ($len < 2) {$day = "0$day"}
	
	$len = length($sec);
	if ($len < 2) {$sec = "0$sec"}
	$len = length($min);
	if ($len < 2) {$min = "0$min"}
	$len = length($hour);
	if ($len < 2) {$hour = "0$hour"}
	$stamp = "$year\-$month\-$day";
	if ($a) {
		$stamp .= "_" . "$hour$min$sec";
	}
	return($stamp);
}

sub open_file_for_write {
	use vars qw($a $b);
	($a) = @_;
	$b = 1;
	if (!open (DATA, ">$a")) {$b = 0}
	return ($b);
}

sub append_open_file_for_write {
	use vars qw($a $b);
	($a) = @_;
	$b = 1;
	if (!open (DATA, ">>$a")) {$b = 0}
	return ($b);
}

sub write_history_data {
	use vars qw($page $var $file_txn_id $datastr 
		$key $val $data_file %hash_data
	);
	($file_txn_id, $data_file, %hash_data) = @_;
	$datastr  = "txn_id=$file_txn_id!!";
	$datastr .= "payer_email=$hash_data{payer_email}!!";
	$datastr .= "payment_status=$hash_data{payment_status}!!";
	$datastr .= "transaction_date=$hash_data{transaction_date}!!";
	while( ($key, $val) = each(%hash_data) ) {  
		if ($key =~ m/txn_id/)  		{next}
		if ($key =~ m/payer_email/)		{next}
		if ($key =~ m/payment_status/)  {next}
		else {
			$datastr .= "$key=$val!!";
		}
	}                                           
	flock(DATA, 2);
	print DATA "$datastr\n";	
	flock(DATA, 8);
	close(DATA);
	chmod (0666, $data_file);
	return(0);
}

sub write_submitted_data {
	use vars qw(%hash_data $xx $x1 $x2 $key $val 
		$item_numbers $item_names $datastr $trans_date $a
		$data_file
	);
	($file_txn_id, $data_file, %hash_data) = @_;
	$a 			= 0;
	$trans_date	= Generic_Date_Stamp($a);
	$datastr  = "txn_id=$file_txn_id!!";							# txn_id
	$datastr .= "payer_email=$hash_data{payer_email}!!";			# purchaser email
	$datastr .= "payment_status=$hash_data{payment_status}!!";		# status
	$datastr .= "transaction_date=$hash_data{transaction_date}!!";	# date
	while( ($key, $val) = each(%hash_data) ) {  
		if ($key =~ m/txn_id/)  {next}
		if ($key =~ m/payer_email/)		{next}
		if ($key =~ m/payment_status/)  {next}
		else {
			$datastr .= "$key=$val!!";
		}
	}                                           
	print DATA "$datastr\n";	
	close (DATA);                               
	chmod (0666, $data_file);
	return(0);
}

sub send_email {
	use vars qw($admin $subject $email $mail_program 
		$msg $page $return_status $etype 
		$print_admin_detail %hash_data);
	
	($email, $admin, $mail_program, $subject, $msg, $return_status, $etype, $print_admin_detail, %hash_data) = @_;
    if (!open (MAIL, "|$mail_program")) {
			return(0);
	}
	if ($print_admin_detail) {$etype = 0}
	print MAIL "To: $email\n";
	print MAIL "From: $admin\n";
	print MAIL "Subject: $subject\n\n";

	print MAIL "$msg";
	if (!$etype) {
		if ($return_status eq 'COMPLETED') {
			while( ($key, $val) = each(%hash_data) ) {  
				if ($key =~ m/payment_fee/)	{next}
				else {
					print MAIL "$key = $val\n";
				}
			}                                           
		}
	}
  	close (MAIL);
	return(1);
}

sub reverse_format_dates {
	use vars qw($m $d $y $val $date $len);
	$date = "";
	($val) = @_;
	$len = length($val);
	if ($len != 10) {
		return($date);
	}
	$m = substr($val,5,2);
	$d = substr($val,8,2);

	$date = "$m\-$d\-$y";
	return($date);
}

1;
