#!/usr/bin/perl

#########################################################
#														#
# 			 N O  F R E E  S U P P O R T  !!			#
#														#
#########################################################
#														#
# THERE IS NO FREE SUPPORT OF ANY KIND FOR THIS 		#
# APPLICATION. SO PLEASE DON'T ASK FOR IT, BECAUSE 		#
# IT WILL ONLY MAKE ME MAD & MAY RESULT IN THE PRODUCT	#
# REMOVAL FROM THE MARKET.								#
#														#
#########################################################
#########################################################
#		F R E E  S O F T W A R E  L I C E N S E   		#
#########################################################
#														#
# This PayPal Tools & Interfaces Software 				#
# is Copyright(C) of David W. Van Abel, 2003.			#
#														#
# This program is free software; you can redistribute 	#
# it and/or modify it under the terms of the GNU 		#
# General Public License as published by the Free 		#
# Software Foundation; either version 2 of the License, #
# or (at your option) any later version.				#
#														#
# This program is distributed in the hope that it will 	#
# be useful, but WITHOUT ANY WARRANTY; without even the #
# implied warranty of 									#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  #
# See the GNU General Public License for more details.	#
#														#
# You should have received a copy of the GNU General 	#
# Public License along with this program; if not, write #
# to the Free Software Foundation, Inc., 59 Temple 		#
# Place, Suite 330, Boston, MA  02111-1307  USA			#
# FULL LICENSE IS FOUND AT 								#
# http://opensource.org/licenses/index.html				#
#														#
# David W. Van Abel	- Author							#
# 2131 S. Allison Court									#
# Lakewood, CO USA 80227								#
# 303-249-3855 (V)										#
# dave@vanabel.com										#
# http://vanabel.com									#
# http://perlsources.com								#
# http://ipnhosting.com									#													#
#														#
#########################################################
# 				E N D  O F  L I C E N S E				#
#########################################################

# Version Notes #

#####################################
# WARNING !! NO USER SETTINGS BELOW #
#####################################

use strict;
use vars qw($scriptname $version $ver_date
	$root_dir $write_data_files $data_root_dir
	$data_dir $history_dir $logfile_dir
	$data_file_end $email_admin $print_admin_detail
	$mail_program $do_mail $domain $email_subject
);	

$scriptname = "ipnx.cgi";
$version 	= "1.00";
$ver_date	= "02-14-03";

use CGI;
use MODULES::Ipnx;	# Application Package

use vars qw($query $ua $req $res @pairs $pair $count 
	$receiver_email $txn_id $payer_email $page %hash_data 
	$var $key $val $msg $data_file $to_email $chk_it 
	$return_status $pending_status $file_txn_id $error 
	$no_txt_file $dmsg $receiver_email $pending_reason 
	$payer_email $payment_type $trans_date $a $send_back 
	$b $c $history_file $etype $atrans_date $std_date
);

require "MODULES/Ipnx_Config.pl";	# File for setting application variables

$page 	= new CGI;
$error	= 0;
$msg 	= "";

# READ POST #

read (STDIN, $query, $ENV{'CONTENT_LENGTH'});
$query .= '&cmd=_notify-validate';

# POST BACK #

use LWP::UserAgent;
$ua  = new LWP::UserAgent;
$req = new HTTP::Request 'POST','https://www.paypal.com/cgi-bin/webscr';
$req->content_type('application/x-www-form-urlencoded');
$req->content($query);
$res = $ua->request($req);

foreach $var ($page->param) {
	$hash_data{$var} = $page->param($var);
}

$a = 0;
$trans_date	= MODULES::Ipnx::Generic_Date_Stamp($a);
$hash_data{'transaction_date'} = $trans_date;
$std_date = MODULES::Ipnx::reverse_format_dates($trans_date);
$hash_data{'standard_date'} = $std_date;
$return_status 	= uc($hash_data{'payment_status'});
$pending_status	= uc($hash_data{'pending_reason'});
$file_txn_id	= ($hash_data{'txn_id'});
$receiver_email	= $hash_data{'receiver_email'};
$receiver_email	=~ s/\s//g;
$payment_type	= uc($hash_data{'payment_type'});

# CHECK CONTROL #

if ($receiver_email ne $email_admin) {
	$msg  = "Paypal has sent a transaction that does not belong to $domain. Email name received = $receiver_email";
	$a = 1;
	$atrans_date	= MODULES::Ipnx::Generic_Date_Stamp($a);
	if (!$file_txn_id) {$file_txn_id = "NonePassed"}
	if ($write_data_files) {
		$data_file = "$root_dir/$logfile_dir/ERROR-" . "$atrans_date" . "_" . "$file_txn_id" . $data_file_end;
		$chk_it = MODULES::Ipnx::open_file_for_write($data_file);
		if (!$chk_it) {
			$dmsg = "Can not open ERROR data file = $data_file";
			$no_txt_file = 1;
		}
		if (!$no_txt_file) {							
			$_ = MODULES::Ipnx::write_submitted_data($data_file, %hash_data);
		}	                                            
	}
	print "content-type: text/plain\n\nOK\n";	# this is what the sample code contained
	$send_back 	= 1;
	$error   	= 1;
}

# WRITE DATA #

if ((!$error) && ($write_data_files)) {
	$data_file = "$data_root_dir/$data_dir/$file_txn_id" . $data_file_end;
	$chk_it = MODULES::Ipnx::append_open_file_for_write($data_file);
	if (!$chk_it) {
		$dmsg = "Can not open data file = $data_file";
		$no_txt_file = 1;
	}
	if (!$no_txt_file) {							
		$error = MODULES::Ipnx::write_submitted_data($file_txn_id, $data_file, %hash_data);
	}	                                            
}

# WRITE HISTORY #

if ((!$error) && ($write_data_files)) {
	$a = 0;
	$_	= MODULES::Ipnx::Generic_Date_Stamp($a);
	$history_file  	 = substr($_,0,4);
	$history_file 	.= substr($_,5,2);
	$history_file 	.= "\.txt";
	$data_file 		 = "$data_root_dir/$history_dir/$history_file";
	$chk_it 		 = MODULES::Ipnx::append_open_file_for_write($data_file);
	if (!$chk_it) {
		$dmsg = "Can not open history data file = $data_file";
		$no_txt_file = 1;
	}
	if ($chk_it) {
		$error = MODULES::Ipnx::write_history_data($file_txn_id, $data_file, %hash_data);
	}
}

# EVERYTHING OK #

if (!$error) {
	print "content-type: text/plain\n\nOK\n";	# this is what the sample code contained
	$send_back = 1;
}

# SEND EMAILS #

if (!$error) {
	if ($do_mail) {
		$to_email = $hash_data{'payer_email'};
		$etype = 0;
		if ($return_status ne 'COMPLETED') {
			$msg   = "Your order at Paypal / $domain has been received.\n";
			$msg  .= "Completion is pending due to $hash_data{'pending_reason'}.\n";
			$chk_it = MODULES::Ipnx::send_email($to_email, $email_admin, $mail_program, $email_subject, $msg, $return_status, $etype, 0, %hash_data);
			if (!$chk_it) {
				$msg = "Order email not sent. It failed. Manual sending required. To = $to_email, Transaction ID = $file_txn_id";
				$error = 1;
			}
		}
		if ($return_status eq 'COMPLETED') {
			$msg  	= "Your order at Paypal / $domain has been completed.\n\n";
			$chk_it = MODULES::Ipnx::send_email($to_email, $email_admin, $mail_program, $email_subject, $msg, $return_status, $etype, 0, %hash_data);

			if (!$chk_it) {
				$msg = "Order email not sent. It failed. Manual sending required. To = $to_email, Transaction ID = $file_txn_id";
				$error = 1;
			}
		}
		$etype = 1;
		if (!$error) {
			if ($return_status eq 'COMPLETED') {
				$a    = "ADMIN $return_status - $domain / Paypal Sale Completed";
				$msg  = "Order from $hash_data{'payer_email'}, transaction no = $hash_data{'txn_id'} is $return_status.\n\n";
			}
			if ($return_status ne 'COMPLETED') {
				$a    = "ADMIN $return_status - $pending_status - $domain / Paypal Sale";
				$msg  = "Order from $hash_data{'payer_email'}, transaction no = $hash_data{'txn_id'} is $return_status due to reason = $pending_status.\n\n";
			}
			$chk_it = MODULES::Ipnx::send_email($email_admin, $email_admin, $mail_program, $a, $msg, $return_status, $etype, $print_admin_detail, %hash_data);
			if (!$chk_it) {
				$msg = "Admin email not sent. It failed. Transaction ID = $file_txn_id";
				$error = 1;
			}
		}
	}
}
if ($do_mail) {
	$etype = 1;
	if ($error) {
		$email_subject = "ADMIN ERROR MESSAGE - $domain / Paypal";
		$msg = $dmsg;
		if ($print_admin_detail) {$print_admin_detail =0}
		$chk_it = MODULES::Ipnx::send_email($email_admin, $email_admin, $mail_program, $email_subject, $msg, $return_status, $etype, $print_admin_detail, %hash_data);
	}
}
if (!$send_back) {
	print "content-type: text/plain\n\nOK\n";
}

# DONE #
