<?

// ---------------------------------------------------------------------------
// functions

function query_splice($query, $type) {
	if (!empty ($query)) {
		$query = $query." ".$type." "; 
		return $query;
	}
}

function query_add_property_array($query, $property_name, $property_value, $and_or='AND', $equal_like='LIKE', $fuzzy='%') {
	if (isset($property_value) && $property_value != "") {
		if (is_array($property_value)) {
			$property_array = $property_value;
		}
		else {
			$property_array = preg_split("/[\s,]+/", $property_value);
		}
		$property_query = "";
		for ($i = 0; $i < count($property_array); $i++)
		{
			$property_query = query_splice($property_query, $and_or).$property_name." $equal_like '".$fuzzy.$property_array[$i].$fuzzy."'"; 
		}
		$property_query = "( ".$property_query." )";
		$query = query_splice($query, 'and').$property_query;
	}
	return $query;
}

function query_add_property($query, $property_name, $property_value, $equal_like='LIKE', $fuzzy='%') {
	if (isset($property_value) && $property_value != "") {
		$query = query_splice($query, 'AND')."( ".$property_name." $equal_like '".$fuzzy.$property_value.$fuzzy."' )";
	}
	return $query;
}

function query_add_date_range_property($query, $property_name, $property_value_month, $property_value_day, $property_value_year, $greater_less) {
	if (!empty($property_value_month) || !empty($property_value_day) || !empty($property_value_year)) {
		$property_value_date = $property_value_year.$property_value_month.$property_value_day;
		$query = query_splice($query, 'AND')."( ".$property_name." ".$greater_less." ".$property_value_date." )";
	}
	return $query;
}

function print_contact_sheet($array, $array_type, $columns = 3, $max = 999) {
	if ($max > count($array)) {
		$max = count($array);
	}
	if (count($array) == 0) {
		print("<p style=\"padding-left: 5px;\">No photos to display.");
	}
	else {
// check array_type, can handle list of IDs or URLs
		$extra = $max % $columns;
		if ($array_type == "URLs") {
// write out table
			print("	<table width=\"100%\" cellpadding=\"7\" cellspacing=\"0\" border=\"0\">\n");
			for ($i = 0; $i < $max; $i++) {
				if ($i == 0 || (($i + $columns) % $columns == 0)) {
					print("		<tr valign=\"top\">\n");
				}
				set_time_limit(99999);

				$last_slash_pos = strrpos($array[$i], "/") + 1;
				$file_name = substr($array[$i],$last_slash_pos);
				
				$temp = "temp_thumb_".$i;
				$thumbnail = save_JPEG_file_from_JPEG($array[$i], 160, "temp/", $temp, 70);

				print("			<td align=\"center\"><img src=\"".$thumbnail."\" class=\"onePixelBorder\"><br>".$file_name."</td>\n");
				if (($i + 1) == $max) {
					for ($o = 0; $o < ($columns - $extra); $o++) {
						print("			<td align=\"center\"></td>\n");
					}
				}
				if (($i + 1) % $columns == 0) {
					print("		</tr>\n");
				}
			}
			print("		</tr>\n");
			print("	</table>\n");
		} 
		elseif ($array_type == "id_list") {
// write out table
			print("	<table width=\"100%\" cellpadding=\"7\" cellspacing=\"0\" border=\"0\">\n");
			for ($i = 0; $i < $max; $i++) {
				if ($i == 0 || (($i + $columns) % $columns == 0)) {
					print("		<tr valign=\"top\">\n");
				}
				set_time_limit(99999);

				$temp_image = new image;
				$temp_image = $temp_image->retrieve($array[$i]);
				
				print("			<td align=\"center\">\n");
				print("				<a href=\"index.php?screen=view&id=".$temp_image->id."\"><img src=\"show_image_from_db.php?id=".$temp_image->id."\" class=\"onePixelBorder\"></a><br>\n");
				print("				<a href=\"index.php?screen=view&id=".$temp_image->id."\">".$temp_image->URL."</a>\n");
				print("			</td>\n");
				if (($i + 1) == $max) {
					for ($o = 0; $o < ($columns - $extra); $o++) {
						print("			<td align=\"center\"></td>\n");
					}
				}
				if (($i + 1) % $columns == 0) {
					print("		</tr>\n");
				}
			}
			print("		</tr>\n");
			print("	</table>\n");
		}
		else {
			print("<p class=\"error\">Please specify \$array_type as: URLs or id_list.");
		}
	}
}

function trim_add_elipsis($string, $limit = 100) {
	if (strlen($string) > $limit) {
		$string = substr($string, 0, $limit)."...";
	}
	return $string;
}

function get_copy_entry_values($id=0) { // if $id is set, retrieve that record - otherwise get the last image entered
	
	global $init_string;
	
	$shortcut_data = new image;

	if ($id != 0) {
		$init_string = $init_string." copyEntryData('retrieved');";
		$shortcut_data->retrieve($id);
	}
	else {
		$temp = mysql_query("SELECT MAX(dateentered) FROM images WHERE (needdetails != '1')")
			or die("error: ".mysql_error());
		$temp = mysql_result($temp,0);
		$id = mysql_query("SELECT ID FROM images WHERE (dateentered = '".$temp."') ORDER BY ID DESC")
			or die("error: ".mysql_error());
		$id = mysql_result($id,0);
		$shortcut_data->retrieve($id);
 	}
// set variables

	$shortcut_data = $shortcut_data->convert_quotes_to_HTML();

	return $shortcut_data;
}

function load_photos($path) {
	global $photo_URLs;
	if ($handle = opendir($path)) {
		if (substr($path, -1, 1) != "/") {
			$path = $path."/";
		}
		while (false !== ($file = readdir($handle))) {
		
			set_time_limit(99999);

			if ($file != "." && $file != "..") { 
				if (is_file($path.$file) && strtolower(substr($file, -4, 4)) == ".jpg") {
					$photo_URLs[] = $path.$file;
				}
				elseif (is_dir($path.$file)) {
					$temp = $path.$file."/";
					load_photos($temp);				
				}
			}
		}
	}
	closedir($handle);
	
	sort($photo_URLs, SORT_STRING);
	
	return $photo_URLs;
}

function clean_up_temp_dir() {
	$path = "temp/";
	if ($handle = opendir($path)) {
		$temp = mktime() - 7200;
		while (false !== ($file = readdir($handle))) {
			set_time_limit(99999);
			if ($file != "." && $file != "..") { 
// only delete files older than 2 hours
				if (filemtime($path.$file) < $temp) {
// delete temp display images
					if (is_file($path.$file) && substr($file, 0, 17) == "temp_display_img_") {
						unlink($path.$file);
					}
// delete temp thumb images
					if (is_file($path.$file) && substr($file, 0, 11) == "temp_thumb_") {
						unlink($path.$file);
					}
// delete load folder thumb images
					if (is_file($path.$file) && substr($file, 0, 18) == "load_folder_thumb_") {
						unlink($path.$file);
					}
				}
			}
		}
	}
	closedir($handle);
}

function save_JPEG_file_from_JPEG($original, $size = 160, $path = "temp/", $file_name = "temp", $quality = 70) {
// read a JPEG and write it back out to another file, can change size
	$new_filename = $path.$file_name.".jpg";
	$original = @imagecreatefromJPEG($original);
	if (!$original) {
		return false;
	}
	else {
// resize image
		set_time_limit(99999);

		if (imagesx($original) > imagesy($original)) {		
			$new_w = $size;
			$img_scale_ratio = imagesx($original)/$new_w;
			$new_h = imagesy($original)/$img_scale_ratio;
			$new_h = floor($new_h);
		}
		else {
			$new_h = $size;
			$img_scale_ratio = imagesy($original)/$new_h;
			$new_w = imagesx($original)/$img_scale_ratio;
			$new_w = floor($new_w);
		}
// save resized image as file
		$temp_img = imagecreatetruecolor($new_w,$new_h);
		imagecopyresized($temp_img,$original,0,0,0,0,$new_w,$new_h,imagesx($original),imagesy($original));
		$temp_img = imageJPEG($temp_img, $new_filename, $quality);
		
		if ($temp_img != false) {
			return $new_filename;
		}
		else {
			return false;
		}
	}
}

function read_exif_data_quick($path) {
/*
	$temp = "/temp/read_exif_data_quick.temp";
	$in = fopen($path, "r");   
	$out = fopen($temp, "w");
	fwrite($out, fread($in, 25000));
	fclose($in); 
	fclose($out);
	return read_exif_data($temp);
*/
	return read_exif_data($path);
}

function get_unique_id() {
	$id = microtime();
	$id = str_replace(" ", "_", $id);
	$id = str_replace(".", "_", $id);
	return $id;
}

function is_in_database($property, $value) {
	$query = "SELECT ".$property." FROM images WHERE (".$property." = '".$value."')";
	$result = mysql_query($query);
	$results = mysql_fetch_array($result);
	if (count($results) > 1) {
		return true;
	}
	else {
		return false;
	}
}

function get_preview_dimensions($original) {
	$original = @imagecreatefromJPEG($original);
	if (!$original) {
		return false;
	}
	else {
		set_time_limit(99999);
		
		$dimensions = array();
// default sizes for preview images		
		$sizes = array(800
		              ,640
		              ,320
		              );
		
		for ($i = 0; $i < count($sizes); $i++) {
			if (imagesx($original) > imagesy($original)) {		
				$new_w = $sizes[$i];
				$img_scale_ratio = imagesx($original)/$new_w;
				$new_h = imagesy($original)/$img_scale_ratio;
				$new_h = floor($new_h);
			}
			else {
				$new_h = $sizes[$i];
				$img_scale_ratio = imagesy($original)/$new_h;
				$new_w = imagesx($original)/$img_scale_ratio;
				$new_w = floor($new_w);
			}
			$dimensions[] = array($new_w
				                 ,$new_h
				                 );
		}
		return $dimensions;
	}
}

?>
