#!/usr/bin/perl

###############################################################################
# imageSearch.cgi                                                             #
###############################################################################
#
# ImageFolio v 2.1 by BizDesign, Inc.
# written by Greg Raaum, webmaster@imageFolio.com
# Available from http://www.ImageFolio.com
# ---------------------------------------------------------------------------
# PROGRAM NAME : ImageFolio 2.1
# VERSION : 2.1
# LAST MODIFIED : 04/17/2000
# ===========================================================================
# COPYRIGHT NOTICE :
#
# Copyright (c) 1999-2000 BizDesign, Inc. All Rights Reserved.
# Selling the code for this program without prior written consent is
# expressly forbidden.
#
# Obtain written permission before redistributing this software over the 
# Internet or in any other medium.  In all cases copyright and header must
# remain intact.
#
# Feel free to modify the code of this program to suit your likings. 
#
# Although this program has been thoroughly tested on BizDesign's servers, we
# do not warrant that it works on all servers and will not be held liable
# for anything, including but not limited to, misusage, error, or loss of data.
#
# Use at your own risk!
###############################################################################

# Do not modify below this line unless you know what you are doing.
###############################################################################

eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows

    require "config.pl";               # Change this to full path to config.pl if you have problems.
    &top;
};

if ($@) { print "Content-type: text/plain\n\nError including configuration file: $@\n"; }
exit;

###############################################################################
# TOP
# Determines what to do
###############################################################################
sub top {
   $|++;   # flush output
   $incoming = $ENV{'QUERY_STRING'};
   @pairs = split(/&/, $incoming);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $FORM{$name} = $value;
   }

   &parse_form;
   &search;
}

###############################################################################
# SEARCH
# Performs the search on the image database created by build.pl
###############################################################################
sub search {

   if (!$FORM{'search'}) {
      &build_pull_down_menu;
      &build_nav;
      &get_page_number;
      $FORM{'search'} = qq|&quot; &quot;|;
      &search_error ("You did not enter any search terms!<br>No results matched your search.");
   }

   if ($protect_images eq "1") { &protect; }
   &search_index;
   &build_pull_down_menu;
   &get_page_number;
   &build_thumbnail_table;
   &build_nextprev_links;
   &build_nav;

   if ($FORM{'search'} eq "NEW") {
      open (TEMPLATE,"$new_template") || die "Content-type: text/html\n\nCould not open $new_template.  Reason $! \n";
   }
   elsif ($FORM{'search'} eq "RANDOM") {
      open (TEMPLATE,"$random_template") || die "Content-type: text/html\n\nCould not open $random_template.  Reason $! \n";
   }
   else {
      open (TEMPLATE,"$search_template") || die "Content-type: text/html\n\nCould not open $search_template.  Reason $! \n";
   }

   while (<TEMPLATE>) {
      if (/<!--#include\s+(virtual|file)\s*=\s*"*([^"\s]*)"*\s*-->/i) { $template .= &ssi_include($2); }
      else { $template .= $_; }
   }
close(TEMPLATE);

   $template =~ s/%%%PULLDOWN_MENU%%%/$pulldown_menu/ig;
   $template =~ s/%%%SEARCH_BOX%%%/$search_box/ig;
   $template =~ s/%%%NAV%%%/$nav/ig;
   $template =~ s/%%%QUERY%%%/$FORM{'search'}/ig;
   $template =~ s/%%%PAGELINKS%%%/$pagelinks/g;
   $template =~ s/%%%PREVIOUS_PAGE%%%/$prevpage/ig;
   $template =~ s/%%%SITE_TITLE%%%/$site_title/ig;
   $template =~ s/%%%PROTECT%%%/$protection/ig;
   $template =~ s/%%%SEARCH_INFO%%%/$pageinfo/ig;
   $template =~ s/%%%IFIMAGES%%%/$if_images_directory/ig;

   if ($totalnames >= 1) {
   $template =~ s/%%%THUMBNAILS%%%/$thumbimages/ig;
   }
   else {
   $template =~ s/%%%THUMBNAILS%%%//ig;
   }

   if ($totalnames > $numtolist) {
      $template =~ s/%%%PAGES_LINKED%%%/$nextlinks/ig;
      $template =~ s/%%%NEXT_PAGE%%%/$nextpage/ig;
   }
   else {
      $template =~ s/%%%PAGES_LINKED%%%//ig;
      $template =~ s/%%%NEXT_PAGE%%%//ig;
   }

   print "Content-type: text/html\n\n";
   print $template;
}

###############################################################################
# BUILD THUMBNAIL TABLE
# build $numtolist thumbnails on a page by reading the array names
###############################################################################
sub build_thumbnail_table {

$imgtable_width = int (100 / $columns);
$imgtable_width .= "%";
$i=0;
$count=0;

my $img = $FORM{'img'};
$RESULTS=@names;
my($most) = $img + $numtolist;

$thumbimages .= qq|<tr bgcolor="$thumb_table_border_color"><td valign=top align=center>
<table border="0" cellspacing=1 cellpadding=4 width="100%">|;

   if ($most > $RESULTS) { $most = $RESULTS; }

   for ($cnt=$img; $cnt < $most; $cnt++) {
   ($name, $path, $filesize, $filedate, $keywords) = split(/\|/, $names[$cnt]);

      if ($count==0){ $thumbimages .= qq|<tr bgcolor="$thumb_table_bgcolor">|; }

      ($linkimage) = $name =~ m,^(.*)\.\w+$,;
      $linkimage =~ s/$mypattern//g;

         if ($display_thumbcaption) {
            $newlink  = $path;
            $newlink  =~ s/\//\./g;
            $newlink = "$data_directory/$newlink.tcaptions.txt";
            $thumbcaption = "";
            $tshortname = $linkimage;

            if (-e "$newlink"){
               open (CAPTIONS,"$newlink");
               while (<CAPTIONS>) {
                  chomp $_;
                  my($image_filename, $tcaption) = split(/\t/,$_);
                  next if !$tcaption;
                  ($new_image_filename) = $image_filename =~ m,^(.*)\.\w+$,;
                  if ($new_image_filename eq $tshortname) {
                     $thumbcaption = $tcaption . "<br>";
                     last;
                  }
               }
               close(CAPTIONS);
            }
         }

      foreach $key (keys %extensions) {
         if ( -e "$image_directory/$path/$linkimage.$key" ) {
            $if_filetype =  $extensions{$key}[0];
            $if_link     =  $extensions{$key}[1];
            $if_tagtype  =  $extensions{$key}[2];
            $if_target   =  $extensions{$key}[3];
            $linkimage   =  $linkimage . ".$key";
            $clink       =  qq|</a>|;
            $newname     =  $linkimage;
            $file_type   =  $if_filetype;
            $extfound    =  1;
            $statimage = "$image_directory/$path/$linkimage";
            ($filesize, $filedate) = (stat($statimage))[7,9];   #get size, timestamp
            $filedate = &unix_to_date($filedate);               #convert unix time to a legible day

            if ($if_link == 1) {
               $slink =  qq|<a href="$imagefolio_url?action=view&link=$path&image=|;
               $slink .= qq|$linkimage&img=$FORM{'img'}&search=$query&cat=$cat&tt=$if_tagtype" target="$if_target">|;
            }
            else {
               $slink = qq|<a href="$imageurl/$path/$linkimage" target="$if_target">|;
            }
            last;
         }
      }

      if (!$extfound) {
         $statimage = "$image_directory/$path/$name";
         ($filesize, $filedate) = (stat($statimage))[7,9];    #get size, timestamp
         $filedate = &unix_to_date($filedate);               #convert unix time to a legible day
         $slink = "";
         $clink = "";
         $file_type = "Not Found!";
         $newname = $name;
      }

      if ($filesize < 1500) { $filesize = commify($filesize) . " bytes"; }
      else { $filesize = int($filesize/1000) . " Kb"; }

      &show_thumbnail;
      $count++;

      if ($count==$columns) {
         $thumbimages .= qq|</tr>|;
         $count=0;
      }
      $i++;
   }

   if ($count>0)  {
      $leftover = ($columns - $count);
      if ($leftover >=1 ) {
         $thumbimages .= qq|<td>&nbsp;</td>| x $leftover;
         $thumbimages .= qq|</tr>|;
      }
   }

$thumbimages .= qq|</table></td></tr>|;
}

###############################################################################
# SEARCH INDEX
# Performs the actual searching of the index file (database)
###############################################################################
sub search_index {

$query = $FORM{'search'};
$query =~ s/\s+/\%20/g;

   if (!$FORM{'cat'}) { $cat = "all"; }
   else { $cat = $FORM{'cat'}; }
   if (!$FORM{'img'}) { $FORM{'img'} = "0"; }

my $pos = $FORM{'img'};
my($SIZE,$i);
@names = ();

open (FILE,"$indexfile") || die "Content-type: text/html\n\nCan't Open $indexfile, is it created?: $!\n";
my(@LINES)=<FILE>;
close(FILE);

if ($FORM{'search'} eq "RANDOM") { &shuffle(\@LINES); }

$SIZE=@LINES;

@search = split(/\s+/, $FORM{'search'});
    $totalnames = 0;
    $d = 0;

   while ($d < $SIZE) {

      foreach $search(@search) {
         ($name,$path,$filesize,$filedate) = split(/\|/, $LINES[$d]);

         if ($FORM{'search'} eq "NEW") {
            if (-M "$image_directory/$path/$name" <= $new_date) {
               push(@names, $LINES[$d]);
               $found = 1;
               $totalnames++;
            }
         }
         elsif ($FORM{'search'} eq "RANDOM") {
            push(@names, $LINES[$d]);
            $found = 1;
            $totalnames++;
         }
         elsif (index(lc $LINES[$d],lc $search) >= 0) {
            if ($cat && $cat ne "all") {
               if ($path =~ /^$cat/ig) {
                  push(@names, $LINES[$d]);
                  $found = 1;
                  $totalnames++;
               }
            }
            else {
               push(@names, $LINES[$d]);
               $found = 1;
               $totalnames++;
            }
         }
      }
      $d++;
   }
   if (!$found) {
     &build_pull_down_menu;
     &build_nav;
     &get_page_number;
     &search_error ("No results matched your search.");
   }
}

###############################################################################
# BUILD NEXTPREV LINKS
# Generate links to additional image pages and next/previous links if necessary
###############################################################################
sub build_nextprev_links {

$num = $totalnames;
$calc = int(($num / $numtolist)+ '0.99');
  if (!$numtolist) { $numtolist = 10; }
$base = $numtolist;

   if (!$FORM{'img'} || $FORM{'img'} eq "0") {
      $FORM{'img'} = "0";
      $nextfactors = $numtolist;
      $nextlinks .= qq|(<b>1</b>)&nbsp;&nbsp;|;
      $thisfactor = 1;
   }

   foreach $linkpage (2..$calc) {
      $factors = (($base * $linkpage) - $base);
      if ($FORM{'img'} == $factors) {
         $thisfactor = $linkpage;
      }
      push(@factorials, $linkpage);
   }

   $numpage_links = @factorals;
   $leftpos1 = $thisfactor - 3;
   $leftpos2 = $thisfactor - 2;
   $leftpos3 = $thisfactor - 1;
   $righpos1 = $thisfactor + 1;
   $righpos2 = $thisfactor + 2;
   $righpos3 = $thisfactor + 3;
   $nextfactor = $righpos1;
   $nextfactors = (($base * $nextfactor) - $base);
   $prevfactor = $leftpos3;
   $prevfactors = (($base * $prevfactor) - $base);

   foreach $factor (@factorials) {
      $factors = (($base * $factor) - $base);
      if ($factor == $leftpos1) { $leftlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$factors&cat=$cat">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $leftpos2) { $leftlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$factors&cat=$cat">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $leftpos3) { $leftlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$factors&cat=$cat">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $thisfactor) { $currentpage .= qq|(<b>$thisfactor</b>)&nbsp;&nbsp;|;
      if ($factor <= 4) { $pageone = qq|<b><a href="$ENV{'SCRIPT_NAME'}?search=$query&img=0&cat=$cat">1</a></b>&nbsp;&nbsp;|; }}
      if ($factor == $righpos1) { $rightlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$factors&cat=$cat">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $righpos2) { $rightlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$factors&cat=$cat">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $righpos3) { $rightlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$factors&cat=$cat">$factor</a></b>&nbsp;&nbsp;|; }
      $lastfactor = $factor;
  }

   $nextlinks .= $pageone . $leftlinks . $currentpage . $rightlinks;

   if ($lastfactor > $thisfactor) {
      $next_page_link = "$ENV{'SCRIPT_NAME'}?search=$query&img=$nextfactors&cat=$cat";
      $nextpage = qq|<a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$nextfactors&cat=$cat">Next [&gt;&gt;]</a>|;
   }
   else {
      $next_page_link = "";
      $nextpage = "";
   }

   if (!$FORM{'img'} || $FORM{'img'} eq "0") {
      $previous_page_link = "";
      $prevpage = "";
   }
   else {
      $previous_page_link = "$ENV{'SCRIPT_NAME'}?search=$query&img=$prevfactors&cat=$cat";
      $prevpage = qq|<a href="$ENV{'SCRIPT_NAME'}?search=$query&img=$prevfactors&cat=$cat">[&lt;&lt;] Prev</a>&nbsp;&nbsp;|;
   }

   if ($num > $numtolist) { $page = "pages"; $image = "images"; }
   else { $page = "page"; $image = "image"; }

   if ($most = $RESULTS) {
      $pageinfo = qq|$num $image found on $calc $page.<br>
      Displaying $numtolist images per page.</font></b><br>|;
   }
}

###############################################################################
# SHOW THUMBNAIL
# this is where we show what each thumbnail will look like
# called from gen_image_table
###############################################################################
sub show_thumbnail {

($shortname) = $newname =~ m,^(.*)\.\w+$,;

   if ($display_fileinfo eq "1") { $thumbalign = "bottom"; }
   else { $thumbalign = "center"; }

$thumbimages .= qq|<td valign="$thumbalign" width="$imgtable_width">
<table border=0 cellspacing=1 cellpadding=4 width="100%"><tr>
<td align="$image_alignment">$slink<img
src="$imageurl/$path/$name" border=0 alt="$alt_text">$clink|;

   if ($display_fileinfo eq "1") {
      $thumbimages .= qq|</td></tr><tr>
      <td valign=top bgcolor="$table_background_color"><$font>|;
      if ($display_filename eq "1") { $thumbimages .= qq|<b>$shortname</b><br>|;  }
      if ($display_thumbcaption)    { $thumbimages .= qq|$thumbcaption|;          }
      if ($display_filetype eq "1") { $thumbimages .= qq|$file_type<br>|;         }
      if ($display_filesize eq "1") { $thumbimages .= qq|Size: $filesize<br>|;    }
      if ($display_date eq "1")     { $thumbimages .= qq|Added: $filedate<br>|;   }
      $thumbimages .= qq|</font>|;
   }

$thumbimages .= qq|</td></tr></table></td>|;
}

###############################################################################
# BUILD NAV
# creates previous, home, and next link buttons if necessary
###############################################################################
sub build_nav {

   if ($previous_page_link) {
      $nav .= qq|<a href="$previous_page_link"><img src="$previous_image" border=0 alt="Previous Page"></a>|;
   }

$nav .= qq|<a href="$homelink"><img src="$home_image"
border=0 alt="Return to Home Page"></a><a href="$imagesearch_url?img=0&search=NEW"><img src="$newlyadd_image"
border=0 alt="Newly Added"></a><a href="$imagesearch_url?img=0&search=RANDOM"><img src="$random_image"
border=0 alt="Random Display"></a>|;

   if ($next_page_link) {
      $nav .= qq|<a href="$next_page_link"><img src="$next_image" border=0 alt="Next Page"></a>|;
   }

}

###############################################################################
# BUILD PULL DOWN MENU
# Here we read the image directory get a list of directory names
# the names are then put in the @alldirectories
###############################################################################
sub build_pull_down_menu {

# First, let's create a pull-down navigation menu of categories

$pulldown_menu .= qq|
<form method=post action="$imagefolio_url">
<table border=0 cellspacing=0 cellpadding=1><tr><td>
<select name="direct">|;

opendir (DIR, $image_directory) || die ("Error Reading Directory:", "$!");
@files = readdir(DIR);
closedir (DIR);
@files = sort { lc($a) cmp lc($b) } @files;

@alldirectories = ();
   foreach $file (@files) {
      if ( -d "$image_directory/$file" ) {            #make sure this really is a directory
         chop $file if ($file =~ /\/$/);
         next if $file =~ /^\.\.?$/;                  #weed out all .. directories
         next if $file =~ /_vti_cnf/i;                #weed out front page directories
         push(@alldirectories, $file);
      }
   }

   foreach $directory (@alldirectories) {
      $mydirectory = $directory;
      $mydirectory =~ s/_/ /g;
      $catlist .= qq|<option value="$directory"> - $mydirectory</option>|;
   }

$pulldown_menu .= qq|
$catlist</select></td><td><input type=image src="$if_images_directory/view.gif" border=0></td>
</tr></table></form>|;


# now we get the search box

if ($FORM{'search'} eq "RANDOM" || $FORM{'search'} eq "NEW") { $searchtag = ""; }
else { $searchtag = $FORM{'search'}; }

$search_box .= qq|<form method=get action="$ENV{'SCRIPT_NAME'}" name="SearchForm">
<input type=hidden name="img" value="0">

<table border=0 cellspacing=0 cellpadding=1><tr><td>
<input type=text size=20 maxlength=75 name=search value="$searchtag"></td>
<td><select name=cat>|;

$thiscat = get_category($cat);

if ($cat ne "all") { $search_box .= qq|<option selected value="$cat">- $thiscat|; }

$search_box .= qq|<option value="all"> - All Categories$catlist</select></td><td><input type=image src="$if_images_directory/search.gif" border=0></td></tr></table>

<SCRIPT LANGUAGE="JavaScript">
<!-- Script Hiding...
document.SearchForm.search.focus();
// End Hiding -->
</SCRIPT>

</form>
|;

}

###############################################################################
# GET CATEGORY
# Returns a string of the search path containing the category broken up 
###############################################################################
sub get_category {
   my $input = shift;
   my (@categories, $output, $path, $last);
   @categories = split (/\//, $input);
   $last = pop @categories;
   $last =~ s/_/ /g;
   $output = $last;
   return $output;
}

###############################################################################
# GET PAGE NUMBER
# Figures out where we are in the search results and uses that in the link bar
###############################################################################
sub get_page_number {

if ($FORM{'search'} eq "NEW") { $searchphrase = "Newly Added"; }
elsif ($FORM{'search'} eq "RANDOM") { $searchphrase = "Random Display"; }
else { $searchphrase = "Search Results"; }

$pagelinks = qq|<$font><a href="$homelink">Top</a> &gt;
<a href="$ENV{'SCRIPT_NAME'}?search=$query&img=0&cat=$cat">$searchphrase</a>|;


   if ($totalnames > $numtolist) {
      if ($FORM{'img'}) { $imagecount = $FORM{'img'}; }
      else { $imagecount = "0"; }
      $pagenumber = int($imagecount / $numtolist);
      $pagenumber++;

      if ($pagenumber eq "1") { $pagelinks .= qq| &gt; Page 1</font>|; }
      else { $pagelinks .= qq| &gt; Page $pagenumber</font>|; }
   }
}

###############################################################################
# PROTECT
# called from print_image_table if image protection is turned on.  Generates a
# javascript that presents the site visitor with an alert message if the right
# mouse button is used on the page.  Very simple, but effective.
###############################################################################
sub protect {
$protection .= qq|

<!-- Powered by BizDesign ImageFolio 2.1 - http://www.imagefolio.com -->
 
<script language="JavaScript1.1">
<!-- Begin
function right(e) {
if (navigator.appName == 'Netscape' && 
(e.which == 2 \|\| e.which == 3)) {
alert('$protection_message');
return false;
}
else if (navigator.appName == 'Microsoft Internet Explorer' && 
(event.button==2 \|\| event.button == 3)) {
alert('$protection_message');
return false;
}
return true;
}
document.onmousedown=right;
if (document.layers) window.captureEvents(Event.MOUSEDOWN);
window.onmousedown=right;
//  End -->
</script>
|; 
}

###############################################################################
# SEARCH FORM
# Search again form if no results are found or no search terms are entered
###############################################################################
sub search_form {

if ($FORM{'search'} eq "RANDOM" || $FORM{'search'} eq "NEW") { $searchtag = ""; }
else { $searchtag = $FORM{'search'}; }

print qq|<form method=get action="$ENV{'SCRIPT_NAME'}" name="SearchForm">
<input type=hidden name="img" value="0">
<input type=hidden name="cat" value="all">

<table border=0 cellspacing=0 cellpadding=1><tr><td>
<input type=text size=30 maxlength=75 name=search value="$searchtag"></td>
<td><input type=image src="$if_images_directory/search.gif" border=0></td></tr></table>

<SCRIPT LANGUAGE="JavaScript">
<!-- Script Hiding...
document.SearchForm.search.focus();
// End Hiding -->
</SCRIPT>

</form>|;

}

###############################################################################
# SSI INCLUDE
# Funtion to include an external page called via SSI tags
###############################################################################
sub ssi_include {
   my ($includefile) = shift;
   open (EXTERNAL,"$includefile") || die "Content-type: text/html\n\nCould not open $includefile.  You must use an absolute path $! \n";
   my(@filelines)=<EXTERNAL>;
   foreach $fileline (@filelines) { $external .= $fileline; }
   close(EXTERNAL);
   return $external;
}

###############################################################################
# COMMIFY
# puts commas in those large numbers
###############################################################################
sub commify {
   my $text = reverse $_[0];
   $text =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
   return scalar reverse $text;
}

###############################################################################
# SHUFFLE
# Shuffles the array containing our index.txt file to display random images
###############################################################################
sub shuffle {
   my $LINES = shift;
   my $l;
   for ($l = @$LINES; --$l; ) {
      my $m = int rand ($l+1);
      next if $l == $m;
      @$LINES[$l,$m] = @$LINES[$m,$l];
   }
}

###############################################################################
# UNIX TO DATE
# Takes in a unix time and coverts it to legible form
###############################################################################
sub unix_to_date {
   my $time   = shift;
   my ($sec, $min, $hour, $day, $mon, $year, $dweek, $dyear, $tz) = localtime $time;
   my @months = qw!01 02 03 04 05 06 07 08 09 10 11 12!;
   $year += 1900;
   return "$months[$mon]/$day/$year";
}

########################################################
# Error
# shows error message if form not filled out correctly
########################################################
sub search_error{
print "Content-type: text/html\n\n";
local ($whoops) = @_;

      $errormsg = qq|<tr bgcolor="$thumb_table_bgcolor"><td><br><br><center>
      <font face="Verdana,Arial,Helvtica" size=2><b><font color="#ff0000">$whoops</font></b>
      <br>You may search again<br>or, <a href="$ENV{'HTTP_REFERER'}">return to
      the previous page</a>.</font><br><br><br></td></tr>|;

open (TEMPLATE,"$search_template") || die "Could not open $search_template.  Reason $! \n";
   while (<TEMPLATE>) {
      if (/<!--#include\s+(virtual|file)\s*=\s*"*([^"\s]*)"*\s*-->/i) { $template .= &ssi_include($2); }
      else { $template .= $_; }
   }
close(TEMPLATE);

   $template =~ s/%%%PULLDOWN_MENU%%%/$pulldown_menu/ig;
   $template =~ s/%%%SEARCH_BOX%%%/$search_box/ig;
   $template =~ s/%%%NAV%%%/$nav/ig;
   $template =~ s/%%%QUERY%%%/$FORM{'search'}/ig;
   $template =~ s/%%%PAGELINKS%%%/$pagelinks/g;
   $template =~ s/%%%PREVIOUS_PAGE%%%//ig;
   $template =~ s/%%%SITE_TITLE%%%/$site_title/ig;
   $template =~ s/%%%PROTECT%%%//ig;
   $template =~ s/%%%SEARCH_INFO%%%//ig;
   $template =~ s/%%%THUMBNAILS%%%/$errormsg/ig;
   $template =~ s/%%%PAGES_LINKED%%%//ig;
   $template =~ s/%%%NEXT_PAGE%%%//ig;
   $template =~ s/%%%IFIMAGES%%%/$if_images_directory/ig;

print $template;
exit;
}

###############################################################################
# PARSE THE FORM
# Parses the form input and returns a hash with all the name
# value pairs. 
###############################################################################
sub parse_form {
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      if ($FORM{$name} && ($value)) { $FORM{$name} = "$FORM{$name},$value"; }
      elsif ($value) { $FORM{$name} = $value; }
   }
}

